; Line drawing procedure by Pablo Reda.
; Some changes by Maciej Guba.
;******************************************* 
linea:	; eax=x1 ebx=y1 ecx=x2 edx=y2
	    ; mm1  - screen buffer
	    ; mm2  - screen width
	    ; mm3  - color 0x00rrggbb
	    ; mm4  - screen size in bytes
	    ; xmm7 - max x, max y
	    ; xmm6 - min x, min y

  ;	 paddd mm4,mm1
	 movlhps   xmm7,xmm7
	 movlhps   xmm6,xmm6
	 paddd	   xmm6,[i1x4]
	 psubd	   xmm7,[i1x4]
	 movd	   xmm0,eax
	 movd	   xmm1,ebx
	 movd	   xmm2,ecx
	 movd	   xmm3,edx
	 pslldq    xmm1,4
	 pslldq    xmm2,8
	 pslldq    xmm3,12
	 por	   xmm0,xmm1
	 por	   xmm0,xmm2
	 por	   xmm0,xmm3
	 movdqa    xmm1,xmm0
	 movdqa    xmm2,xmm0
	 pcmpgtd   xmm1,xmm7
	 pcmpgtd   xmm0,xmm6
	 pxor	   xmm1,xmm0
	 movmskps  edi,xmm1
	 cmp	   edi,0xf
	 jne	   .end



	cmp ebx,edx
	je horizontal 
	jg .noswap 
	xchg eax,ecx 
	xchg ebx,edx 
.noswap: 
	shl eax,16 
	shl ecx,16 
	sub eax,ecx 
	push ebx 
	push edx 
	sub ebx,edx 
	add ebx,1 
	cdq 
	idiv ebx 
	mov esi,eax 
	add ecx,$7fff 
	pop ebx 
	pop edx 
.lineas: 
	mov eax,ecx 
	add eax,esi 
	push ebx 
	push eax 
	shr ecx,16 
	shr eax,16 
	call horizontal 
	pop ecx 
	pop ebx 
	add ebx,1 
	cmp ebx,edx 
	jle .lineas
.end:
	ret

horizontal:  ; eax=x1 ebx=y1 ecx=x2 
	cmp ecx,eax 
	jg .m 
	xchg ecx,eax 
.m: 
	sub ecx,eax 
	jnz .nn
	add ecx,1 
.nn:
	push edx
	movd  edx,mm2
	imul ebx,edx	; mm2 - screen_width_var
	pop  edx
	add eax,ebx
	movd  edi,mm1	; mm1 - line_buffer_var
	lea edi,[edi+eax*4]
.l:
   ;	 movd mm7,edi
   ;	 movd mm6,edi
   ;	 pcmpgtd mm7,mm1
   ;	 pcmpgtd mm6,mm4
   ;	 pxor	mm6,mm7
   ;	 movd	eax,mm6
   ;	  or	 eax,eax
   ;	 jz	@f
	movd [edi],mm3	; mm3 - color
	add edi,4
	loop .l
	ret
