


write_text:
;   eax - x * 65536 + y -> where to display
;   ebx - pointer to character table
;   ecx - size x * 65536 + size y -> size of screen buffer
;   esi - pointer to ASCIIZ string to display
;   edi - pointer to screen buffer
 .x            equ word   [ebp-2]
 .y            equ word   [ebp-4]
 .chr_tab_ptr  equ dword  [ebp-8]
 .xres_m       equ word   [ebp-10]
 .yres_m       equ word   [ebp-12]
 .ascii_string_ptr equ dword  [ebp-16]
 .m_screen_ptr equ dword  [ebp-20]
 .CHAR_X       equ  8
 .CHAR_Y       equ  16
 .CHAR_LN_X    equ  128
 .CHAR_LN_Y    equ  256
      pushad
      mov    ebp, esp
      push   eax
      push   ebx
      push   ecx
      push   esi
      push   edi
   .decode:
      movzx  eax,byte[esi]
   ;  mov    ebx,256
;      sub    ebx,eax
      mov    ebx,eax
 ;     shr    eax,4
      not    eax
      and    eax,0x0000000f
  ;    and    ebx,0x0000000f
      and    ebx,0x000000f0
  ;    shl    ebx,8
      shl    ebx,4
      add    eax,ebx
      add    eax,.chr_tab_ptr   ; eax -> cur position in chr table

      movzx  ebx,.y
      movzx  ecx,.xres_m
      imul   ebx,ecx
      movzx  ecx,.x
      add    ebx,ecx
      shl    ebx,2
      add    ebx,.m_screen_ptr ; ebx - cur position on menu screen
  ;   draw on char, eax char in char table -> 16 bytes
  ;   draw first byte and next 15 bytes
      mov    ecx,16
    .loop1:
      push   ecx
      movzx  edx,byte[eax]
      xor    ecx,ecx
    .inner_loop:
      shr    edx,1
      jc     @f
      mov    [ebx+ecx],dword 0x00ffffff   ; col of written char
    @@:
      add    ecx,4
      cmp    ecx,32
      jnge   .inner_loop

      movzx  ecx,.xres_m
      shl    ecx,2
   ;   sub    ecx,32

      add    ebx,ecx       ; .xres_m menu buffer width*4 in dwords
      add    eax,16        ; 16 chr_tab width  (in bytes)
      pop    ecx
      loop   .loop1
      add    .x,8         ; 8 points of the screen
      add    esi,1
      cmp    [esi],byte 0
      jne    .decode  ; next char ?

      mov   esp,ebp
      popad
ret
write_framee:
    ; mm1  -  buffer ptr
    ; mm2  -  width
    ; mm3  -  color
    ; eax  -  x2 shl 16 + x1
    ; ebx  -  y2 shl 16 + y1
    ; xmm6 -  min x, min y
    ; xmm7 -  max x, max y

     .x2 equ  word[ebp-2]
     .x1 equ  [ebp-4]
     .y2 equ  word[ebp-6]
     .y1 equ  [ebp-8]
     .max equ [ebp-16]
     .min equ [ebp-24]
     push     ebp
     mov      ebp,esp
     sub      esp,24
  ;   and      ebp,-16

     movq     .min,xmm6
     movq     .max,xmm7
     mov      .x1,eax
     mov      .y1,ebx
     movzx     eax,word .x1
     movzx     ebx,word .y1
     movzx     ecx,.x2
     movzx     edx,word .y1
;     movd     mm1,[screen_ptr]
   ;  movd     mm0,[Zbuffer_ptr]
;     movzx    esi,[xres_var]
;     movd     mm2,esi
;     mov      esi,0x0000ff00
;     movd     mm3,esi
     call  linea
     movzx  eax,word .x1
     movzx  ebx,word .y1
     movzx  ecx,word .x1
     movzx  edx,.y2
     movq   xmm6,.min
     movq   xmm7,.max
     call  linea
     movzx  eax,word .x1
     movzx  ebx,.y2
     movzx  ecx,.x2
     movzx  edx,.y2
     movq   xmm6,.min
     movq   xmm7,.max
     call  linea
     movzx  eax,.x2
     movzx  ebx,word .y1
     movzx  ecx,.x2
     movzx  edx,.y2
     movq   xmm6,.min
     movq   xmm7,.max
     call  linea

     mov   esp,ebp
     pop   ebp

ret