; this file contains only next joined mesh routines
Bputpixel:
; in: eax - x + y shl 16
;     cl  - markup
;     esi - color 0x00rrggbb
  emms
  mov     ebx,(BYRES-5) shl 16 +BXRES-5
  movd    mm0,ebx
  mov     ebx,5 shl 16 +5
  movd    mm1,ebx
  movd    mm2,eax
  pmaxsw  mm2,mm1
  pminsw  mm2,mm0

  movd   eax,mm2
  mov    edx,BXRES
  movzx  ebx,ax
  shr    eax,16
  mul    edx
  add    eax,ebx
  shl    eax,2
  add    eax,Bbuffer

  mov     edi,eax              ; draw line handle
  and     esi,0x00ffffff
  mov     al,cl                ; cl -> crucial point number
  shl     eax,24
  or      eax,esi
;  cmp     cl,253
;  jae     .axis
;  or      eax,0x00ff0000
;  jmp     .draw
; .axis:
;  or      eax,0x0000ffff
; .draw:
  sub     edi,2*BXRES*4+20
  mov     ecx,5
  cld
  rep     stosd
  add     edi,BXRES*4-20
  mov     ecx,5
  rep     stosd
  add     edi,BXRES*4-20
  mov     ecx,5
  rep     stosd
  add     edi,BXRES*4-20
  mov     ecx,5
  rep     stosd
  add     edi,BXRES*4-20
  mov     ecx,5
  rep     stosd

  emms
ret

NextMdraw_all:

;in  eax - dword value to fill,
;    ecx - area size in dwords
;    edi - mem adress
;    addres must be aligned
     mov   ecx,BXRES * BYRES
     mov   eax,0xff1f1f1f
     mov   edi,Bbuffer
     call  fill_aligned

 ;    movq   xmm0,[NextMxadd]  ; x, y, z
 ;    packssdw xmm0,xmm0
;     psrlw   xmm0,1
;     mov     ebx,((BYRES shr 1) shl 16) + (BXRES shr 1)
;     movd    xmm1,ebx
;     paddusw xmm0,xmm1
     mov     eax,[NextMxadd]  ;xmm0
     mov     cl,1
     mov     esi,0x0000ffff
     call    Bputpixel  ; write bar on Bbuffer area
     mov     ax,[NextMzadd]
     shl     eax,16
     mov     ax,5
     mov     cl,2
     mov     esi,0x00ff00ff
     call    Bputpixel  ; write bar on Bbuffer area
     mov     ax,[NextScale]
     shl     eax,16
     mov     ax,(BXRES-10)
     mov     cl,3
     mov     esi,0x00ffff00
     call    Bputpixel  ; write bar on Bbuffer area


ret

