detect_chunks:
    push ebp
    mov  ebp,esp
    and  ebp,-16
    sub  esp,60
   .tri_ChunL      equ  dword[ebp-4]    ; tri chunks list ptr
   .chunks         equ  dword[ebp-8]    ; chunks ptreach tri chunk No. as word
   .tri_ChunLCnt   equ  dword[ebp-12]
   .chunks_cnt     equ  dword[ebp-16]
   .sst            equ  dword[ebp-20]   ; store mark
   .cur_ch_ptr     equ  dword[ebp-24]   ; current chunk ptr
   .ch_cnt         equ  dword[ebp-28]   ; "global" chunks counter
   .cur_tCLptr     equ  dword[ebp-32]   ; current tri chunks list pointer
   .std_ptr        equ  dword[ebp-36]   ; marks of stored triangles list

   prompt  prompt_det_chunks ; macro

   mov     ebx,[triangles_count_var]
   shl     ebx,2
   lea     ebx,[ebx*3]
   add     ebx,32
   invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke  MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .tri_ChunL,eax
   mov     .cur_tCLptr,eax

   mov     ebx,[triangles_count_var]
   shl     ebx,1
   invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke  MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .chunks,eax     ; each tri chunk No. as word
   mov     .cur_ch_ptr,eax
   mov     .ch_cnt,0

   shr     ebx,1
   invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke  MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .std_ptr,eax     ; each tri chunk No. as word

   mov     ecx,[points_count_var]
   mov     edi,eax
   xor     eax,eax
   shr     ecx,2
   add     ecx,1
   call    fill_aligned

   mov    esi,[triangles_ptr]
   mov    ecx,[triangles_count_var] ; triangles chunks list counter
   mov    edx,.std_ptr
   mov    edi,.tri_ChunL

  .nx_chunk:
   mov     .sst,0           ; store mark
   mov     .tri_ChunLCnt,1  ; triangles count in one chunk
   inc     .ch_cnt          ; chunk counter
   movdqu  xmm0,[esi]       ; init chunks tris list
   mov     edi,.cur_tCLptr
   movdqu  [edi],xmm0
   mov     [edx],byte 1
   inc     edx
   add     .cur_tCLptr,12
   dec     ecx
   jz      .end
   mov     ebx,.cur_ch_ptr
   mov     eax,.ch_cnt
   mov     [ebx],ax
   add     .cur_ch_ptr,2   ; pararell to esi = Triangles Chunk List
 ;  inc     .tri_ChunLCnt

  .nx_edi:
   push    ecx
   push    esi
   push    edx
  .nx_L:
   movdqu  xmm0,[edi]
   movdqu  xmm1,[esi]
   movd    xmm2,[esi]
   movd    xmm3,[esi+4]
   movd    xmm4,[esi+8]
   pshufd  xmm2,xmm2,0
   pshufd  xmm3,xmm3,0
   pshufd  xmm4,xmm4,0
   pcmpeqd xmm2,xmm0
   pcmpeqd xmm3,xmm0
   pcmpeqd xmm4,xmm0
   por     xmm2,xmm3
   por     xmm2,xmm4
   movmskps eax,xmm2
   and     eax,111b
   cmp     eax,111b
   je      @f       ; the same triangle
   or      eax,eax
   jnz     .store
  @@:
  .nxCh:            ; dec counter of inner loop
   add     esi,12
   add     edx,1
   loop    .nx_L    ; next on the list
   jmp     .isEL    ; is end of loop ?

  .store:
   cmp     byte[edx],1  ; if byte [edx] = 1 ; tri was stored
   je      .nxCh
   inc     .tri_ChunLCnt
   mov     ebx,.cur_tCLptr
   movdqu  [ebx],xmm1
   add     .cur_tCLptr,12
   mov     ebx,.cur_ch_ptr
   mov     eax,.ch_cnt
   mov     [ebx],ax
   add     .cur_ch_ptr,2
   mov     byte[edx],1
   mov     .sst,1
   jmp       .nxCh

  .isEL:
   add     edi,12
   pop     edx
   pop     esi
   pop     ecx
   cmp     .sst,0
   je      @f         ; without store
   dec     .tri_ChunLCnt
   jnz     .nx_edi

 @@:
   mov     esi,.chunks
   xor     ecx,ecx
 @@:
   cmp     word[esi],0
   je      @f
   add     esi,2
   inc     ecx
   cmp     ecx,[triangles_count_var]
   jnz     @b
   jmp     .end            ; all chunks detected
 @@:
   jecxz   .end
   mov     esi,ecx
   mov     ebx,ecx
   mov     edx,ecx
   sub     ecx,[triangles_count_var]
   neg     ecx
   imul    esi,[i12]
   shl     ebx,1
   add     esi,[triangles_ptr]
   add     ebx,.chunks
   add     edx,.std_ptr
   mov     .cur_ch_ptr,ebx
   jmp     .nx_chunk
  .end:
   mov    ebx,.chunks
   mov    ecx,.ch_cnt

   cls    ; macro

   add    esp,60
   pop    ebp
ret
;------------------------------------------------------------------------
write_info:   ; Display unique edges, vertices, faces count, colided edges
              ; and individual chunks info.
    push ebp
    mov  ebp,esp
    sub  esp,100

    .str_ed   equ  [ebp-100]
;    .str_vert equ  [ebp-100]

    xor    eax,eax          ; clear draw buffer
    mov    edi,info_screen
    mov    ecx,INFOX * INFOY
    call   fill_aligned
    mov    eax,5 shl 16 + 2
    mov    ebx,font_table + 62
    mov    ecx,INFOX shl 16 + INFOY
    mov    esi,uniq_ed
    mov    edi,info_screen
    call   write_text
; unsigned dword integer to ascii procedure
;     in   eax - variable
;          esi - Pointer to ascii string
;   out    esi - desired ascii string
;          edi - end of ascii string  - ptr to memory

    mov    eax,[edges_count]
    lea    esi,.str_ed
    call   itoa
    mov    byte[edi+1],0

;   eax - x * 65536 + y -> where to display
;   ebx - pointer to character table
;   ecx - size x * 65536 + size y -> size of scr buffer
;   esi - pointer to ASCIIZ string to display
;   edi - pointer to scr buffer
    mov    eax,5 shl 16 + 19
    mov    ebx,font_table + 62
    mov    ecx,INFOX shl 16 + INFOY
    lea    esi,.str_ed
    mov    edi,info_screen
    call   write_text


    mov    eax,5 shl 16 + 36
    mov    ebx,font_table + 62
    mov    ecx,INFOX shl 16 + INFOY
    mov    esi,faces
    mov    edi,info_screen
    call   write_text

    mov    eax,[triangles_count_var]
    lea    esi,.str_ed
    call   itoa
    mov    byte[edi+1],0

    mov    eax,5 shl 16 + 36 + 17
    mov    ebx,font_table + 62
    mov    ecx,INFOX shl 16 + INFOY
    lea    esi,.str_ed
    mov    edi,info_screen
    call   write_text

    mov    eax,5 shl 16 + 36 + 17*2
    mov    ebx,font_table + 62
    mov    ecx,INFOX shl 16 + INFOY
    mov    esi,vertices
    mov    edi,info_screen
    call   write_text

    mov    eax,[points_count_var]
    lea    esi,.str_ed
    call   itoa
    mov    byte[edi+1],0

    mov    eax,5 shl 16 + 36 + 3*17
    mov    ebx,font_table + 62
    mov    ecx,INFOX shl 16 + INFOY
    lea    esi,.str_ed
    mov    edi,info_screen
    call   write_text

    cmp    [mark_coll_ed_flag],0
    je     @f

    mov    eax,5 shl 16 + 36 + 17*4
    mov    ebx,font_table + 62
    mov    ecx,INFOX shl 16 + INFOY
    mov    esi,edges_inter
    mov    edi,info_screen
    call   write_text

    mov    eax,[edges_coll_count]  ; edges collided count
    lea    esi,.str_ed
    call   itoa
    mov    byte[edi+1],0

    mov    eax,5 shl 16 + 36 + 17*5
    mov    ebx,font_table + 62
    mov    ecx,INFOX shl 16 + INFOY
    lea    esi,.str_ed
    mov    edi,info_screen
    call   write_text
  @@:

    cmp    [srch_chunk_flag],0
    je     @f

    mov    eax,200 shl 16 + 17*0
    mov    ebx,font_table + 62
    mov    ecx,INFOX shl 16 + INFOY
    mov    esi,chunks_info
    mov    edi,info_screen
    call   write_text

    mov    eax,[chunks_count]  ; edges collided count
    lea    esi,.str_ed
    call   itoa
    mov    byte[edi+1],0

    mov    eax,200 shl 16 + 18
    mov    ebx,font_table + 62
    mov    ecx,INFOX shl 16 + INFOY
    lea    esi,.str_ed
    mov    edi,info_screen
    call   write_text
  @@:



    movzx  eax,[xres_var]
    mov    ebx,MYPRES
    add    ebx,2
    invoke StretchDIBits,[hdc],eax,ebx,INFOX,INFOY,0,0,INFOX,INFOY,info_screen,Ibmi,0,SRCCOPY

    mov  esp,ebp
    pop  ebp
ret

;======================================================
normalize_plane_equation:
 movups xmm0,[plane_equation]    ;normalize
 movaps xmm1,xmm0
; andps  xmm0,[zero_hgst_dd]
 mulps  xmm0,xmm0
 haddps xmm0,xmm0
 haddps xmm0,xmm0
; shufps xmm0,xmm0,00000000b
 rsqrtps xmm0,xmm0
 mulps  xmm1,xmm0     ; xmm1 - normalized plane equat.
 movups [plane_equation],xmm1
ret

;=========================================================
fill_aligned:
;in  eax - dword value to fill,
;    ecx - area size in dwords
;    edi - mem adress
;    addres must be aligned
    mov  ebx,ecx
    and  ebx,1111b  ;
    jz   .fill_sse
  @@:
    mov  [edi],eax
    add  edi,4
    sub  ebx,1
    jnz  @b
  .fill_sse:
    shr    ecx,4
    or     ecx,ecx
    jz     .end
    movd   xmm0,eax
    shufps xmm0,xmm0,0
    and    edi,-16 ; to be sure
  @@:
    movaps  [edi],xmm0
    movaps  [edi+16],xmm0
    movaps  [edi+32],xmm0
    movaps  [edi+48],xmm0
    add     edi,64
    loop    @b
   .end:
ret

;===========================================================
norm_aligned_lv:     ; normalise aligned light vectors
;  in edi -> lights_ptr
;     ecx -> lights count
    @@:
     movaps  xmm0,[edi]
     movaps  xmm1,[edi]
     mulps   xmm1,xmm1
     haddps  xmm1,xmm1
     haddps  xmm1,xmm1
     rsqrtps xmm1,xmm1
     mulps   xmm0,xmm1
     movaps  [edi],xmm0
     add     edi,64
     sub     ecx,1
     jnz     @b
ret